# coding: utf-8

"""
    Span

    Span Panel REST API

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations

import pprint
import re  # noqa: F401
from typing import Optional

import orjson as json
from pydantic import BaseModel, Field, StrictInt, StrictStr

from span_panel.client.models.allowed_endpoint_groups import AllowedEndpointGroups


class Client(BaseModel):
    """
    Client
    """

    description: Optional[StrictStr] = None
    issued_at: Optional[StrictInt] = None
    allowed_endpoint_groups: AllowedEndpointGroups = Field(...)
    __properties = ["description", "issued_at", "allowed_endpoint_groups"]

    class Config:
        """Pydantic configuration"""

        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Client:
        """Create an instance of Client from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True, exclude={}, exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of allowed_endpoint_groups
        if self.allowed_endpoint_groups:
            _dict["allowed_endpoint_groups"] = self.allowed_endpoint_groups.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> Client:
        """Create an instance of Client from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return Client.parse_obj(obj)

        _obj = Client.parse_obj(
            {
                "description": obj.get("description"),
                "issued_at": obj.get("issued_at"),
                "allowed_endpoint_groups": (
                    AllowedEndpointGroups.from_dict(obj.get("allowed_endpoint_groups"))
                    if obj.get("allowed_endpoint_groups") is not None
                    else None
                ),
            }
        )
        return _obj
